<link rel="import" href="../../polymer/polymer-element.html">

<dom-module id="table-element">
  <template>
    <style>
      :host {
        display: block;
      }

      table {
        width: 98%;
        border-collapse: collapse;
        margin: 1%;
      }

      th, td {
        padding: 8px;
        text-align: left;
        border-bottom: 1px solid #ddd;
        border-top: 1px solid #ddd;
      }

      tr:nth-child(n+2):nth-child(odd) {
        background-color: #f2f2f2;
      }
    </style>
      <table>
        <template is="dom-if" if="{{notMatch}}" restamp>
          <tr>
              <th>Name</th>
              <th>Last Name</th>
              <th>Amount (YEN)</th>
          </tr>
        </template>
        <template is="dom-if" if="{{!notMatch}}" restamp>
          <tr>
            <th>None Match</th>
          </tr>
        </template> 
        <template is="dom-repeat" items="{{employees}}" filter="{{computeFilter(searchString)}}">
            <tr>
                <td>{{item.firstName}}</td>
                <td>{{item.lastName}}</td>
                <td>{{item.salary}}</td>
            </tr>
        </template> 
      </table>
  </template>

  <script>
    class Table extends Polymer.Element {
      static get is() { return 'table-element'; }
      static get properties() {
        return {
          employees: {
            type: Array,
            notify: true,
            value: function() {
                return [];
            }
          },
          list: {
            type: Array
          },
          searchString: {
            type: String,
            notify: true,
            value: ''
          },
          notMatch: {
            type: Boolean,
            value: true,
            notify: true,
            observer: '_activeChanged'
          }
        };
      }

      constructor(){
        super();
      }

      async connectedCallback(){
        super.connectedCallback();
        await this.fillList();
        this.fillTable();
      }

      async fillList() {
        this.list = await fetch('http://dummy.restapiexample.com/api/v1/employees');
        this.list = await this.list.json();
        this.list = this.list.data;
      }

      fillTable() {
        this.list.forEach( element => {
            let name = element.employee_name.split(' ');
            this.employees.push(new Object({firstName: name[0], lastName: name[1], salary: element.employee_salary}));
        });
        this.employees = this.employees.slice();
      }

      computeFilter(string) {
        if (!string) {
          return null;
        } else {
          string = string.toLowerCase();
          return function(employee) {
            var first = employee.firstName.toLowerCase();
            var last = employee.lastName.toLowerCase();
            if (first.indexOf(string) != -1 || last.indexOf(string) != -1) {
              this.dispatchEvent(new CustomEvent('not-match-changed-var', {bubbles: true, composed: true}));
              return true;
            } else {
              return false;
            }
          };
        }
      }

      _activeChanged(newValue, oldValue) {
        console.log(newValue);
      }

      ready(){
        super.ready();
        this.addEventListener('not-match-changed-var', () => {
          this.notMatch = true;
        });
      }

      changeValue() {
        this.notMatch = true;
      }
      
    }
    window.customElements.define(Table.is, Table);
  </script>
</dom-module>